 % ALGORITMO DE LAS BOTELLAS DE VIDRIO
 % Para construir la spline cubica natural S que interpola a la funcion f,
 % definida en los puntos x(0) < x(1) < ... < x(n), verificando
 % S''(x(0)) = S''(x(n)) = 0:
 %
 % ENTRADA:   n; x(0), x(1), ..., x(n); puede generar A(I) = f(x(I))
 %          para I = 0, 1, ..., n o entrar A(I) para I = 0, 1, ..., n.
 %
 % SALIDA:  A(J), B(J), C(J), D(J) para J = 0, 1, ..., n - 1.
 %
 % NOTE:    S(x) = A(J) + B(J)*( x - x(J) ) + C(J)*( x - x(J) )**2 +
 %          D(J) * ( x - x(J) )**3 for x(J) <= x < x(J + 1) 
 syms('OK','FLAG','N','I','X','A','AA','NAME','INP','F','M','H','XA','espesor')
 syms('XL','XU','XZ','C','J','B','D','OUP','x','s','v','y');
 TRUE=1;
 FALSE=0;
 fprintf(1,'Este es el metodo de obtencion del volumen de botellas de vidrio.\n');
 OK = FALSE;
 while OK == FALSE 
 fprintf(1,'Elija la forma de entrada de datos:\n');
 fprintf(1,'1. Entrada termino a termino desde el teclado\n');
 fprintf(1,'2. Entrada de datos desde un fichero de texto\n');
 fprintf(1,'3. Generar datos usando una funcion F con los nodos introducidos ');
 fprintf(1,'desde el teclado\n');
 fprintf(1,'4. Generar datos usando una funcion F con los nodos de un ');
 fprintf(1,'fichero de texto\n');
 fprintf(1,'Elija 1, 2, 3, o 4 \n');
 FLAG = input(' ');
    if FLAG >= 1 & FLAG <= 4 
 OK = TRUE;
    end
 end
 if FLAG == 1 
 OK = FALSE;
    while OK == FALSE 
 fprintf(1,'Escriba n\n');
 N = input(' ');
        if N > 0 
 OK = TRUE;
 X = zeros(1,N+1);
 A = zeros(1,N+1);
            for I = 0:N 
 fprintf(1,'Escriba X(%d) y F(X(%d)) ', I, I);
 fprintf(1,'en lineas separadas.\n');
 X(I+1) = input(' ');
 A(I+1) = input(' ');
            end
        else fprintf(1,'El numero debe ser entero positivo\n');
         end
    end
 end
 if FLAG == 2 
 fprintf(1,'Ha sido creado un fichero con los datos en dos ');
 fprintf(1,'columnas ?\n');
 fprintf(1,'Escriba Y o N\n');
 AA = input(' ','s');
    if AA == 'Y' | AA == 'y' 
 fprintf(1,'Escriba el nombre del fichero de la forma - ');
 fprintf(1,'disco:\\nombre.ext\n');
 fprintf(1,'Por ejemplo: A:\\DATA.DTA\n');
 NAME = input(' ','s');
 INP = fopen(NAME,'rt');
 OK = FALSE;
        while OK == FALSE 
 fprintf(1,'Escriba n siendo n el numero de intervalos de datos menos uno\n');
 N = input(' ');
             if N > 0
 X = zeros(1,N+1);
 A = zeros(1,N+1);
                for I = 0:N
 X(I+1) = fscanf(INP, '%f',1);
 A(I+1) = fscanf(INP, '%f',1);
                end
 fclose(INP);
 OK = TRUE;
            else 
 fprintf(1,'El numero debe ser entero positivo\n');
            end
        end
    else
 fprintf(1,'Por favor creese el fichero de entrada en dos columnas ');
 fprintf(1,'con los valores de X y F(X) en las columnas correspondientes.\n');
 fprintf(1,'El programa finalizara para que el fichero pueda ser creado.\n');
 OK = FALSE;
    end
 end
 if FLAG == 3
 fprintf(1,'Escriba la funcion F(x) en terminos de x.\n');
 fprintf(1,'For example: cos(x) \n');
 s = input(' ','s');
 F = inline(s,'x');
 OK = FALSE;
    while OK == FALSE
 fprintf(1,'Escriba n\n');
 N = input(' ');
        if N > 0
 X = zeros(1,N+1);
 A = zeros(1,N+1);
         for I = 0:N 
 fprintf(1,'Escriba X(%d)\n', I);
 X(I+1) = input(' ');
 A(I+1) = F(X(I+1));
         end
 OK = TRUE;
        else
 fprintf(1,'El numero debe ser entero positivo\n');
        end
    end
 end
 if FLAG == 4 
 fprintf(1,'Ha sido creado el fichero de texto con los valores de X?\n');
 fprintf(1,'Escriba Y o N\n');
 AA = input(' ','s');
    if AA == 'Y' | AA == 'y' 
 fprintf(1,'Escriba el nombre del fichero de la forma - ');
 fprintf(1,'disco:\\nombre.ext\n');
 fprintf(1,'Por ejemplo:   A:\\DATA.DTA\n');
 NAME = input(' ','s');
 INP = fopen(NAME,'rt');
 fprintf(1,'Escriba la funcion F(x) en terminos de x.\n');
 fprintf(1,'Por ejemplo: cos(x) \n');
 s = input(' ','s');
 F = inline(s,'x');
 OK = FALSE;
        while OK == FALSE 
 fprintf(1,'Escriba n,\n');
 N = input(' ');
            if N > 0
 OK = TRUE;
 X = zeros(1,N+1);
 A = zeros(1,N+1);
                for I = 0:N
 X(I+1) = fscanf(INP, '%f',1);
 A(I+1) = F(X(I+1));
                end
 fclose(INP);
            else fprintf(1,'El numero debe ser entero positivo\n');
            end
        end
     else 
 fprintf(1,'El programa finalizara para que el fichero de entrada pueda ser creado\n');
 OK = FALSE;
    end
 end
 if OK == TRUE 
 M = N - 1;
% STEP 1
 H = zeros(1,M+1);
    for I = 0:M
 H(I+1) = X(I+2) - X(I+1);
    end
% STEP 2
% Use XA in place of ALPHA
 XA = zeros(1,M+1);
    for I = 1:M
 XA(I+1) = 3.0*(A(I+2)*H(I)-A(I+1)*(X(I+2)-X(I))+A(I)*H(I+1))/(H(I+1)*H(I));
    end
% STEP 3
% STEPs 3, 4, 5 and part of 6 solve the tridiagonal system using 
% Crout reduction.
% use XL, XU, XZ in place of L, MU, Z resp.
 XL = zeros(1,N+1);
 XU = zeros(1,N+1);
 XZ = zeros(1,N+1);
 XL(1) = 1;
 XU(1) = 0;
 XZ(1) = 0;
% STEP 4
    for I = 1:M
 XL(I+1) = 2*(X(I+2)-X(I))-H(I)*XU(I);
 XU(I+1) = H(I+1)/XL(I+1);
 XZ(I+1) = (XA(I+1)-H(I)*XZ(I))/XL(I+1);
    end
% STEP 5
 XL(N+1) = 1;
 XZ(N+1) = 0;
 B = zeros(1,N+1);
 C = zeros(1,N+1);
 D = zeros(1,N+1);
 C(N+1) = XZ(N+1);
% STEP 6
    for I = 0:M
 J = M-I;
 C(J+1) = XZ(J+1)-XU(J+1)*C(J+2);
 B(J+1) = (A(J+2)-A(J+1))/H(J+1) - H(J+1) * (C(J+2) + 2.0 * C(J+1)) / 3.0;
 D(J+1) = (C(J+2) - C(J+1)) / (3.0 * H(J+1));
    end
% STEP 7
 fprintf(1,'Elija la forma de salida de datos\n');
 fprintf(1,'1. Pantalla\n');
 fprintf(1,'2. Fichero de texto\n');
 fprintf(1,'Escriba 1 o 2\n');
 FLAG = input(' ');
    if FLAG == 2 
 fprintf(1,'Escriba el nombre del fichero de la forma - disco:\\nombre.ext\n');
 fprintf(1,'Por ejemplo:   A:\\OUTPUT.DTA\n');
 NAME = input(' ','s');
 OUP = fopen(NAME,'wt');
    else 
 OUP = 1;
    end
 fprintf(OUP, 'INTERPOLACION SPLINE CUBICA NATURAL n\n');
 fprintf(OUP, 'Los puntos X(0), ..., X(N) son:\n');
    for I = 0:N
 fprintf(OUP, ' %11.8f', X(I+1));
    end
 fprintf(OUP, '\n\nLos coeficientes de la spline en los subintervalos '); 
 fprintf(OUP, 'son:\n');
 fprintf(OUP, 'Para I = 0, ..., N-1\n');
 fprintf(OUP, '     A(I)          B(I)           C(I)         D(I)\n');
    for I = 0:M
 fprintf(OUP,'%13.8f %13.8f %13.8f %13.8f \n',A(I+1),B(I+1),C(I+1),D(I+1));
    end
    if OUP ~= 1
 fclose(OUP);
 fprintf(1,'Fichero de salida creado satisfactoriamente \n',NAME);
    end
 y = zeros(1,101*(M+1));
 v = zeros(1,101*(M+1));
    for J = 1:M+1    
        for I = 1:101
 v(101*(J-1)+I)=X(J) + (I-1)*(X(J+1)-X(J))/100;
 y(101*(J-1)+I)=A(J)+B(J)*(v(101*(J-1)+I)-X(J))+C(J)*(v(101*(J-1)+I)-X(J))^2+D(J)*(v(101*(J-1)+I)-X(J))^3;
        end
    end
end
 JX= zeros(N);
 XI= zeros(5);
 WI= zeros(5);
 XI(1)= 0.9061798459;
 XI(2)= 0.5384693101;
 XI(3)= 0.0;
 XI(4)= -XI(2);
 XI(5)= -XI(1);
 WI(1)= 0.2369268850;
 WI(2)= 0.4786286705;
 WI(3)= 0.5688888889;
 WI(4)= WI(2);
 WI(5)= WI(1);
 for J=1:N
     JX(J)= 0;
    for I=1:5
        K1=(X(J+1)-X(J))/2;
        K2=(X(J+1)+X(J))/2;
        XX=K1*XI(I)+K2;
        Q=pi*[A(J)+B(J)*(XX-X(J))+C(J)*(XX-X(J))^2+D(J)*(XX-X(J))^3]^2;
        JX(J)=JX(J)+WI(I)*Q;
    end
    JX(J)=JX(J)*K1;
end
INT1=0;
for J=1:N
  INT1=INT1+JX(J);
end
 espesor=0;
fprintf(1,'Escriba espesor en las mismas unidades que introdujo los datos\n');
 espesor= input(' ');
for J=1:N
     JX(J)= 0;
    for I=1:5
        K1=(X(J+1)-X(J))/2;
        K2=(X(J+1)+X(J))/2;
        XX=K1*XI(I)+K2;
        P=pi*[A(J)+B(J)*(XX-X(J))+C(J)*(XX-X(J))^2+D(J)*(XX-X(J))^3-espesor]^2;
        JX(J)=JX(J)+WI(I)*P;
    end
    JX(J)=JX(J)*K1;
end

INT2=0;
for J=1:N
  INT2=INT2+JX(J);
end
INT3=0;
INT3=INT1-INT2;
INT4=0;
INT4=INT1-INT3;
fprintf(1,'\nEl volumen del contenido es la integral de F desde %13.8f hasta %13.8f es\n',0,X(J+1));
fprintf(1,'%13.8f\n',INT4);
fprintf(1,'\nEl volumen del continente es la integral de F desde %13.8f hasta %13.8f es\n',0,X(J+1));
fprintf(1,'%13.8f\n',INT3);
figure(1);
 plot(v(:),y(:),'-r',X(:),A(:),'ok');
 axis([0 X(N+1) 0 X(N+1)]);
 title('Spline Cubica Natural');



   
